package tv.acfun.cloud.service.limit;

import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import tv.acfun.cloud.common.entity.ApiVersion;
import tv.acfun.cloud.common.resolver.JsonArgument;
import tv.acfun.cloud.common.service.CommonService;
import tv.acfun.cloud.service.limit.entity.LimitEntity;
import tv.acfun.cloud.service.user.entity.UserEntity;

import java.util.List;

/**
 * Created by wzp on 16/02/01.
 */
@FeignClient(LimitConstants.LIMIT_SERVICE_ID)
public interface LimitService {
  @RequestMapping(value = LimitConstants.LIMITS_PATH, method = RequestMethod.GET, headers = {ApiVersion.HEADER_API_VERSION_10})
  List<LimitEntity> findByV10(@JsonArgument(value = "user") UserEntity user, @RequestParam(value = "typeId") Long typeId);

  @RequestMapping(value = LimitConstants.LIMITS_PATH+"onlyuser", method = RequestMethod.GET, headers = {ApiVersion.HEADER_API_VERSION_10})
  public List<LimitEntity> findByOnlyUserV10(@JsonArgument("user") UserEntity user, @RequestParam("typeId") Long typeId);

  @RequestMapping(value = LimitConstants.LIMITS_ID_PATH, method = RequestMethod.GET, headers = {ApiVersion.HEADER_API_VERSION_10})
  LimitEntity findByIdV10(@PathVariable("id") Long id);

  @RequestMapping(value = LimitConstants.LIMITS_ID_PATH, method = RequestMethod.DELETE, consumes = MediaType.APPLICATION_JSON_VALUE, headers = {ApiVersion.HEADER_API_VERSION_10})
  LimitEntity deleteByIdV10(@PathVariable("id") Long id, @JsonArgument("limit") LimitEntity limit);

  @RequestMapping(value = LimitConstants.LIMITS_PATH, method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE, headers = {ApiVersion.HEADER_API_VERSION_10})
  LimitEntity saveV10(@JsonArgument("limit") LimitEntity limit);

  @RequestMapping(value = LimitConstants.LIMITS_ID_PATH, method = RequestMethod.PUT, consumes = MediaType.APPLICATION_JSON_VALUE, headers = {ApiVersion.HEADER_API_VERSION_10})
  LimitEntity updateByIdV10(@PathVariable("id") Long id, @JsonArgument("limit") LimitEntity limit);

}
