package tv.acfun.cloud.service.limit;

import org.springframework.cloud.netflix.feign.FeignClient;
import tv.acfun.cloud.common.entity.ApiVersion;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import tv.acfun.cloud.common.entity.Paginate;
import tv.acfun.cloud.common.resolver.JsonArgument;
import tv.acfun.cloud.common.service.CommonService;
import tv.acfun.cloud.service.limit.entity.ReasonEntity;

import java.util.List;

/**
 * Created by wzp on 16/02/01.
 */
@FeignClient(LimitConstants.LIMIT_SERVICE_ID)
public interface ReasonService {
  @RequestMapping(value = LimitConstants.REASONS_PATH, method = RequestMethod.GET, headers = {ApiVersion.HEADER_API_VERSION_10})
  Paginate findByV10(@JsonArgument(value = "reason") ReasonEntity reason, @JsonArgument(value = "paginate") Paginate paginate);

  @RequestMapping(value = LimitConstants.REASONS_ID_PATH, method = RequestMethod.GET, headers = {ApiVersion.HEADER_API_VERSION_10})
  ReasonEntity findByIdV10(@PathVariable("id") Long id);

  @RequestMapping(value = LimitConstants.REASONS_ID_PATH, method = RequestMethod.DELETE, consumes = MediaType.APPLICATION_JSON_VALUE, headers = {ApiVersion.HEADER_API_VERSION_10})
  ReasonEntity deleteByIdV10(@PathVariable("id") Long id, @JsonArgument("reason") ReasonEntity reason);

  @RequestMapping(value = LimitConstants.REASONS_PATH, method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE, headers = {ApiVersion.HEADER_API_VERSION_10})
  ReasonEntity saveV10(@JsonArgument("reason") ReasonEntity reason);

  @RequestMapping(value = LimitConstants.REASONS_ID_PATH, method = RequestMethod.PUT, consumes = MediaType.APPLICATION_JSON_VALUE, headers = {ApiVersion.HEADER_API_VERSION_10})
  ReasonEntity updateByIdV10(@PathVariable("id") Long id, @JsonArgument("reason") ReasonEntity reason);

}
