package tv.acfun.cloud.service.limit;

import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import tv.acfun.cloud.common.entity.ApiVersion;
import tv.acfun.cloud.common.entity.Paginate;
import tv.acfun.cloud.common.resolver.JsonArgument;
import tv.acfun.cloud.service.limit.entity.TypeEntity;

import java.util.List;

/**
 * Created by wzp on 16/02/01.
 */
@FeignClient(LimitConstants.LIMIT_SERVICE_ID)
public interface TypeService {
  @RequestMapping(value = LimitConstants.TYPES_PATH, method = RequestMethod.GET, headers = {ApiVersion.HEADER_API_VERSION_10})
  Paginate findByV10(@JsonArgument(value = "type") TypeEntity type, @JsonArgument(value = "paginate") Paginate paginate);

  @RequestMapping(value = LimitConstants.TYPES_ID_PATH, method = RequestMethod.GET, headers = {ApiVersion.HEADER_API_VERSION_10})
  TypeEntity findByIdV10(@PathVariable("id") Long id);

  @RequestMapping(value = LimitConstants.TYPES_ID_PATH, method = RequestMethod.DELETE, consumes = MediaType.APPLICATION_JSON_VALUE, headers = {ApiVersion.HEADER_API_VERSION_10})
  TypeEntity deleteByIdV10(@PathVariable("id") Long id, @JsonArgument("type") TypeEntity type);

  @RequestMapping(value = LimitConstants.TYPES_PATH, method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE, headers = {ApiVersion.HEADER_API_VERSION_10})
  TypeEntity saveV10(@JsonArgument("type") TypeEntity type);

  @RequestMapping(value = LimitConstants.TYPES_ID_PATH, method = RequestMethod.PUT, consumes = MediaType.APPLICATION_JSON_VALUE, headers = {ApiVersion.HEADER_API_VERSION_10})
  TypeEntity updateByIdV10(@PathVariable("id") Long id, @JsonArgument("type") TypeEntity type);

}
