package tv.acfun.cloud.service.limit.entity;

import lombok.Data;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.DBRef;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by wzp on 16/02/01.
 */
@Data
@Document(collection = "lmt_limit")
public class LimitEntity implements Serializable {
  /**
   * 主键
   */
  @Id
  private Long id;

  /**
   * 封禁内容Id
   */
  private Long channelId;

  /**
   * 开始时间
   */
  @Field(value = "started_at")
  private Date startedAt;

  /**
   * 过期时间
   */
  @Field(value = "expired_at")
  private Date expiredAt;

  /**
   * 创建者Id
   */
  @Field(value = "creater_id")
  private Long createrId;

  /**
   * 创建时间
   */
  @Field(value = "created_at")
  private Date createdAt;

  /**
   * 更新者Id
   */
  @Field(value = "updater_id")
  private Long updaterId;

  /**
   * 更新时间
   */
  @Field(value = "updated_at")
  private Date updatedAt;

  /**
   * 删除者Id
   */
  @Field(value = "deleter_id")
  private Long deleterId;

  /**
   * 删除时间
   */
  @Field(value = "deleted_at")
  private Date deletedAt;

  /**
   * 关联Entity：封禁原因
   */
  @DBRef
  private ReasonEntity reason;

  /**
   * 关联Entities：封禁类型，登录、弹幕、评论
   */
  @DBRef
  private List<TypeEntity> types;

  /**
   * 关联Entities：封禁目标列表
   */
  @DBRef
  private List<TargetEntity> targets;
}
