package tv.acfun.cloud.service.limit.entity;

import lombok.Data;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;

import java.io.Serializable;

/**
 * Created by wzp on 15/11/22.
 */
@Data
@Document(collection = "lmt_target")
public class TargetEntity implements Serializable {
  /**
   * 主键
   */
  @Id
  private Long id;

  /**
   * 关联属性：封禁Id
   */
  @Field(value = "limit_id")
  private Long limitId;

  /**
   * 封禁目标类型(user:1; role:2; all:3)
   */
  @Field(value = "type")
  private Integer type;

  /**
   * 封禁目标Id：userId; roleId; -1
   */
  @Field(value = "target_id")
  private Long targetId;

}
