package tv.acfun.cloud.service.limit.entity;

import lombok.Data;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;

import java.io.Serializable;
import java.util.Date;

/**
 * Created by wzp on 16/02/01.
 */
@Data
@Document(collection = "lmt_type")
public class TypeEntity implements Serializable {
  /**
   * 主键
   */
  @Id
  private Long id;

  /**
   * 封禁类型值(login:1; comment:2; danmaku:3)
   */
  private String value;

  /**
   * 封禁类型名称(登录、评论、发弹幕)
   */
  private String name;

  /**
   * 封禁类型简介
   */
  private String intro;

  /**
   * 创建者Id
   */
  @Field(value = "creater_id")
  private Long createrId;

  /**
   * 创建时间
   */
  @Field(value = "created_at")
  private Date createdAt;

  /**
   * 更新者Id
   */
  @Field(value = "updater_id")
  private Long updaterId;

  /**
   * 更新时间
   */
  @Field(value = "updated_at")
  private Date updatedAt;

  /**
   * 删除者Id
   */
  @Field(value = "deleter_id")
  private Long deleterId;

  /**
   * 删除时间
   */
  @Field(value = "deleted_at")
  private Date deletedAt;
}
