package tv.acfun.cloud.service.limit.repository;

import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Pageable;
import tv.acfun.cloud.common.mongo.CommonMongoRepository;
import tv.acfun.cloud.common.service.ServiceConfig;
import tv.acfun.cloud.service.limit.LimitConstants;
import tv.acfun.cloud.service.limit.entity.LimitEntity;

import java.util.Date;
import java.util.List;

/**
 * Created by wzp on 16/02/02.
 */
@CacheConfig(cacheNames = LimitConstants.LIMITS_CACHE, cacheResolver = ServiceConfig.REPOSITORY_CACHE_RESOLVER)
public interface LimitRepository extends CommonMongoRepository<LimitEntity, Long> {

  @Cacheable
  List<LimitEntity> findByExpiredAtAfterAndDeletedAtNull(Date date);

  @Cacheable
  List<LimitEntity> findByExpiredAtAfterAndIdInAndDeletedAtNull(Date date, Long... id);

  @Cacheable
  List<LimitEntity> findByIdInAndDeletedAtNull(Long... id);

  @Cacheable
  LimitEntity findByIdAndDeletedAtNull(Long id);

  @Cacheable
  List<LimitEntity> findByCreaterIdAndDeletedAtNull(Long userId, Pageable pageable);

  @Cacheable
  List<LimitEntity> findByDeletedAtNull();
}
