package tv.acfun.cloud.service.limit.repository;

import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Pageable;
import tv.acfun.cloud.common.mongo.CommonMongoRepository;
import tv.acfun.cloud.common.service.ServiceConfig;
import tv.acfun.cloud.service.limit.LimitConstants;
import tv.acfun.cloud.service.limit.entity.ReasonEntity;

import java.util.List;

/**
 * Created by wzp on 16/02/02.
 */
@CacheConfig(cacheNames = LimitConstants.REASONS_CACHE, cacheResolver = ServiceConfig.REPOSITORY_CACHE_RESOLVER)
public interface ReasonRepository extends CommonMongoRepository<ReasonEntity, Long> {
  @Cacheable
  ReasonEntity findByIdAndDeletedAtNull(Long id);

  @Cacheable
  List<ReasonEntity> findByCreaterIdAndDeletedAtNull(Long createrId, Pageable pageable);

  @Cacheable
  List<ReasonEntity> findByDeletedAtNull(Pageable pageable);

  @CacheEvict(allEntries = true, value = {LimitConstants.REASONS_CACHE, LimitConstants.LIMITS_CACHE})
  ReasonEntity save(ReasonEntity entity);
}
