package tv.acfun.cloud.service.limit.repository;

import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.Cacheable;
import tv.acfun.cloud.common.mongo.CommonMongoRepository;
import tv.acfun.cloud.common.service.ServiceConfig;
import tv.acfun.cloud.service.limit.LimitConstants;
import tv.acfun.cloud.service.limit.entity.TargetEntity;

import java.util.List;

/**
 * Created by wzp on 16/02/02.
 */
@CacheConfig(cacheNames = LimitConstants.TARGETS_CACHE, cacheResolver = ServiceConfig.REPOSITORY_CACHE_RESOLVER)
public interface TargetRepository extends CommonMongoRepository<TargetEntity, Long> {
  @Cacheable
  List<TargetEntity> findByType(Integer type);

  @Cacheable
  List<TargetEntity> findByTypeAndTargetId(Integer type, Long targetId);

  @Cacheable
  List<TargetEntity> findByTypeAndTargetIdIn(Integer type, Long... targetId);

}
