package tv.acfun.cloud.service.limit.repository;

import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Pageable;
import tv.acfun.cloud.common.mongo.CommonMongoRepository;
import tv.acfun.cloud.common.service.ServiceConfig;
import tv.acfun.cloud.service.limit.LimitConstants;
import tv.acfun.cloud.service.limit.entity.TypeEntity;

import java.util.List;

/**
 * Created by wzp on 16/02/02.
 */
@CacheConfig(cacheNames = LimitConstants.TYPES_CACHE, cacheResolver = ServiceConfig.REPOSITORY_CACHE_RESOLVER)
public interface TypeRepository extends CommonMongoRepository<TypeEntity, Long> {
  @Cacheable
  TypeEntity findByIdAndDeletedAtNull(Long id);

  @Cacheable
  List<TypeEntity> findByCreaterIdAndDeletedAtNull(Long userId, Pageable pageable);

  @Cacheable
  List<TypeEntity> findByDeletedAtNull(Pageable pageable);

  @CacheEvict(allEntries = true, value = {LimitConstants.TYPES_CACHE, LimitConstants.LIMITS_CACHE})
  TypeEntity save(TypeEntity entity);
}
